/**
 * Copyright (C) 2006  Bull S. A. S.
 * Bull, Rue Jean Jaures, B.P.68, 78340, Les Clayes-sous-Bois
 * This library is free software; you can redistribute it and/or modify it under the terms
 * of the GNU Lesser General Public License as published by the Free Software Foundation
 * version 2.1 of the License.
 * This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with this
 * program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth
 * Floor, Boston, MA  02110-1301, USA.
 **/
package org.ow2.orchestra.axis;

import javax.xml.soap.SOAPMessage;

import org.apache.axis.soap.SOAPConnectionImpl;
import org.ow2.orchestra.facade.exception.OrchestraRuntimeException;

public final class AxisSOAPUtil {

  private AxisSOAPUtil() {

  }

  public static SOAPMessage call(final SOAPMessage soapMessage, final String endpoint, final int timeout) {
    SOAPMessage response = null;
    SOAPConnectionImpl connection = null;
    try {
      connection = new SOAPConnectionImpl();
      connection.setTimeout(timeout);
      response = connection.call(soapMessage, endpoint);
    } catch (final Exception e) {
      throw new OrchestraRuntimeException("Exception caught while performing call", e);
    } finally {
      if (connection != null) {
        try {
          connection.close();
        } catch (final Exception e) {
          // nothing
        }
      }
    }
    return response;
  }

}

